VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Sheet1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Private Sub CommandButton1_Click()                                              '1
 
Dim vi       As Long                                                            '3
Dim ret      As Long
Dim msg      As String
Dim err_msg  As String * 256                                                    '6
 
'Starting the session *******************************************
ret = age5270_init("GPIB::17::INSTR", VI_TRUE, VI_TRUE, vi)                     '9
If ((vi = VI_NULL) Or (ret < VI_SUCCESS)) Then                                 '10
  msg = "Initialization failure." & Chr(10) & Chr(10) & "Status Code:  " & ret
  MsgBox msg, vbOKOnly, ""
  If (vi <> VI_NULL) Then
    ret = age5270_error_message(vi, ret, err_msg)
    msg = "Error:  " & ret & Chr(10) & Chr(10) & err_msg
    MsgBox msg, vbOKOnly, ""
  End If
  End
End If                                                                         '19
 
ret = age5270_reset(vi)                      'Resets E5270.                    '21
ret = age5270_timeOut(vi, 60000)             'Sets time out to 60 sec.
ret = age5270_errorQueryDetect(vi, VI_TRUE)  'Enables error detection.

perform_meas vi, ret                  'Calls perform_meas subprogram.           25
'ret = age5270_cmd(vi, "aa")           'Sends invalid command.
'check_err vi, ret                     'Checks check_err subprogram operation.
 
'Closing the session ********************************************
ret = age5270_close(vi)                                                        '30
check_err vi, ret
 
msg = "Press OK to stop the program."                                          '33
MsgBox msg, vbOKOnly, ""
 
CommandButton1.Caption = "Start Measurement"                                   '36
 
End Sub
Sub perform_meas(vi As Long, ret As Long) '1
Dim pins(4) As Long 'SMU port numbers f3
pins(0) = 1 'SMU1: drain
pins(1) = 2 'SMU2: gate
pins(2) = 4 'SMU4: source
pins(3) = 6 'SMU6: substrate
ret = age5270_setSwitch(vi, pins(3), 1) '9
ret = age5270_setSwitch(vi, pins(2), 1)
ret = age5270_setSwitch(vi, pins(1), 1)
ret = age5270_setSwitch(vi, pins(0), 1)
check_err vi, ret '13
spot_meas vi, ret, pins() '15
ret = age5270_setSwitch(vi, age5270_CH_ALL, 0) '17
check_err vi, ret
End Sub
Sub spot_meas(vi As Long, ret As Long, pins() As Long) '1
Dim vd As Double '3
Dim vg As Double
Dim idcomp As Double
Dim igcomp As Double
Dim meas As Double
Dim status As Long
vd = 0.5
idcomp = 0.05
vg = 0.5
igcomp = 0.01 '12
Dim base As Double '14
Dim width As Double
Dim period As Double
Dim hold As Double
base = 0
width = 0.001
period = 0.01
hold = 0.1 '21
CommandButton1.Caption = "Measurement in progress . . ." '23
msg = "Press OK to start measurement. "
MsgBox msg, vbOKOnly, ""
ret = age5270_setPbias(vi, pins(1), age5270_VF_MODE, 2, base, vg, width, period, hold, igcomp) '27
ret = age5270_force(vi, pins(3), age5270_VF_MODE, 0, 0, 0.05, 0)
ret = age5270_force(vi, pins(2), age5270_VF_MODE, 0, 0, 0.05, 0)
ret = age5270_force(vi, pins(0), age5270_VF_MODE, 2, vd, idcomp, 0)
check_err vi, ret '33
ret = age5270_measureP(vi, pins(0), age5270_IM_MODE, 0, meas, status, 0) '35
check_err vi, ret
ret = age5270_zeroOutput(vi, age5270_CH_ALL) '38
check_err vi, ret
CommandButton1.Caption = "Measurement completed." '41
display_data meas, status, vi, ret, pins() '43
End Sub '45
Sub display_data(meas As Double, status As Long, vi As Long, ret As Long, pins() As Long)
Dim title As String '3
Dim value As String
Dim rbx As Integer
title = "Spot Measurement Result" '6
If status = 0 Then '8
value = "Id = " & meas * 1000 & " (mA)" & Chr(10) & Chr(10)
value = value & "Do you want to perform measurement again?"
rbx = MsgBox(value, vbYesNo + vbQuestion, title)
If rbx = vbYes Then
spot_meas vi, ret, pins()
End If
Else
value = "Status error. Code = " & status
MsgBox value, vbOKOnly, title
End If '18
End Sub

Sub check_err(vi As Long, ret As Long)
 Dim inst_err    As Long
 Dim err_message As String * 250
 Dim retStatus   As Long
 If VI_SUCCESS > ret Then
  If (age5270_INSTR_ERROR_DETECTED = ret) Then
    retStatus = age5270_error_query(vi, inst_err, err_message)
    msg = "Instrument Error:  " & inst_err & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  Else
    retStatus = age5270_error_message(vi, ret, err_message)
    msg = "Driver Error:  " & ret & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  End If
 End If
End Sub
