Imports Ivi.visa.interop

Module Module1

    Sub Main()

        Dim B1500 As IResourceManager
        Dim session As IMessage
        B1500 = New ResourceManager
        session = B1500.Open("GPIB0::17::INSTR")
        session.WriteString("*RST" & vbLf)

        Dim fmt As Integer = 1 : session.WriteString("FMT" & fmt & vbLf)
        Dim t() As Integer = {4, 3, 2, 1}  'Drain, Gate, Source, Sub

        Dim v0 As Double = 0 : Dim vd As Double = 1 : Dim idcomp As Double = 0.1
        Dim vg As Double = 0.8 : Dim igcomp As Double = 0.05
        Dim orng As Integer = 0 : Dim mrng As Integer = 0
        Dim hold As Double = 0.1 : Dim width As Double = 0.01 : Dim period As Double = 0.02


        Dim mem As Integer = 1
        session.WriteString("ST" & mem & vbLf)
        session.WriteString("DV" & t(3) & ",0,0,0.1" & vbLf)
        session.WriteString("DV" & t(2) & ",0,0,0.1" & vbLf)
        session.WriteString("DV" & t(1) & "," & orng & "," & vg & "," & igcomp & vbLf)
        session.WriteString("DV" & t(0) & "," & orng & "," & vd & "," & idcomp & vbLf)
        session.WriteString("TI" & t(0) & "," & mrng & vbLf)
        session.WriteString("END" & vbLf)
        display_mem(session, mem)

        mem = 2
        session.WriteString("ST" & mem & vbLf)
        session.WriteString("PT" & hold & "," & width & "," & period & vbLf)
        session.WriteString("DV" & t(3) & ",0,0,0.1" & vbLf)
        session.WriteString("DV" & t(2) & ",0,0,0.1" & vbLf)
        session.WriteString("PV" & t(1) & "," & orng & "," & v0 & "," & vg & "," & igcomp & vbLf)
        session.WriteString("DV" & t(0) & "," & orng & "," & vd & "," & idcomp & vbLf)
        session.WriteString("MM3," & t(0) & vbLf)
        session.WriteString("RI" & t(0) & "," & mrng & vbLf)
        session.WriteString("XE" & vbLf)
        session.WriteString("END" & vbLf)
        display_mem(session, mem)

        Dim term As String = t(0) & "," & t(1) & "," & t(2) & "," & t(3)
        session.WriteString("CN" & term & vbLf)
        Dim i As Integer : Dim ret As Integer : Dim msg As String
        Dim value As String : Dim status As String : Dim meas As Double
        For i = 1 To 2
            session.WriteString("DO" & i & vbLf)
            session.WriteString("*OPC?" & vbLf) : ret = session.ReadString(1 + 2)
            session.WriteString("ERR? 1" & vbLf) : ret = session.ReadString(4 + 2)
            If ret <> 0 Then session.WriteString("DZ" & vbLf) : GoTo Check_err
            value = session.ReadString(17) : status = Left(value, 3)
            value = Mid(value, 4, 12) : meas = Val(value)
            Console.WriteLine("Memory " & i & ": Id = " & meas & " (A), Status = " & status & Chr(10))
        Next
        session.WriteString("DZ" & vbLf)
        session.WriteString("CL" & vbLf)
        session.Close()
        MsgBox("Completed", vbOKOnly, "")
        Exit Sub

Check_err:
        session.WriteString("EMG? " & ret & vbLf) : msg = session.ReadString(256)
        MsgBox("Instrument error: " & ret & Chr(10) & msg, vbOKOnly, "")
        Exit Sub
    End Sub

    Sub display_mem(ByVal session As IMessage, ByVal mem As Integer)
        session.WriteString("LST?" & mem & vbLf)
        Dim prog_list As String = session.ReadString(256)
        Console.WriteLine("Memory " & mem & ":")
        Console.WriteLine(prog_list & Chr(10))
    End Sub


End Module
