#include <stdio.h>
#include "E5270_TIS.h"

main()
{
int ret;

#ifdef E5270_TIS_H
	ret = open_E5270( "GPIB0::17::INSTR" , ERR_DETECT_ON,NULL);
	if ( ret != 0 ) {
					printf( "Failed to open E5270. Exit program.\n" );
					return( -1 );
					}
#endif

int drain, gate, source, sub;
double vd1, vd2, vg, ig_c, irange, vrange, icomp, current;
double width, period, hold;

vg = 1.5;
vd1 = 0.0;
vd2 = 1.5;
vrange = 2.0;
width = 1e-3;
period = 10e-3;
hold = 50e-3;
irange = 100e-3;
ig_c = 5e-3;
icomp = 50e-3;

drain = 15;
gate = 16;
source = 17;
sub = 18;

init_system();
connect_pin(SMU1, drain);
connect_pin(SMU2, gate);
connect_pin(SMU4, source);
connect_pin(SMU6, sub);

force_v(sub, 0.0, vrange, icomp);
force_v(source, 0.0, vrange, icomp);
force_v(gate, vg, vrange, ig_c);
set_pbias(drain, V_SOURCE, vrange, vd1, vd2, width, period, hold, icomp);
measure_p(drain, I_MEAS, &current, irange);
disable_port(0);
disconnect_all();

	printf("Id = %8.6f mA (at %2.1f V)\n", current*1000, vd2);
	printf("Vg = %8.6f V\n", vg);

#ifdef E5270_TIS_H
	close_E5270();
#endif
	return( 0 );
}